#include "clock.hpp"

#include "eink/eink.hpp"
#include "flash/flash.hpp"
#include "io/io.hpp"
#include "uart/uart.hpp"

#include "image.hpp"

using uart_t = uart::Uart0<uart::Config<115200>>;
REGISTER_UART0_INT_VECTORS(uart_t);

using spi_t = eink::Spi<io::P::C4, io::P::C5, io::P::C3, io::P::C2>;
using eink_t = eink::Eink<200, 200, spi_t, io::P::C1, io::P::C0>;

int main()
{
	uart_t serial;
	serial.init();

	sei();

	serial << F("e-Paper demo") << F("\r\n");

	auto einkDisplay = eink_t{};

	serial << F("e-Paper init") << F("\r\n");
	einkDisplay.init();

	serial << F("e-Paper clear") << F("\r\n");
	einkDisplay.clear();

	serial << F("e-Paper draw") << F("\r\n");
	einkDisplay.draw(RLE_IMAGE);

	serial << F("e-Paper sleep") << F("\r\n");
	einkDisplay.sleep();

	while (true) {
		serial << F("e-Paper running") << F("\r\n");
		_delay_ms(1000);
	}

	return 0;
}
